﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Configuration;

namespace DropBoxService
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class Dropbox : System.Web.Services.WebService
    {
        #region CheckFilename
        [WebMethod]
        public string CheckFileName(String FileName, String UploadSecret)
        {
            // decode the input
            String CurrentFilename = FileName;
            Int32 Counter = 1;

            if (UploadSecret != ConfigurationSettings.AppSettings["UploadSecret"])
            {
                return "UploadSecret wrong!";
            }

            while (File.Exists(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"] + CurrentFilename)))
            {
                CurrentFilename = Counter + "_" + FileName;
                Counter++;
            }

            return CurrentFilename;
        }
        #endregion

        #region DropFile
        [WebMethod]
        public string DropFile(byte[] Data, String FileName, bool Append, String UploadSecret)
        {
            // decode the input
            String CurrentFilename = FileName;
            Int32 Counter = 1;

            if (UploadSecret != ConfigurationSettings.AppSettings["UploadSecret"])
            {
                return "UploadSecret wrong!";
            }

            try
            {
                //byte[] Data = System.Convert.FromBase64String(Base64_Encoded_File);

                while (File.Exists(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"] + CurrentFilename)))
                {
                    CurrentFilename = Counter + "_" + FileName;
                    Counter++;
                }

                MemoryStream ms = new MemoryStream(Data);
                
                FileStream fs;

                if (!Append)
                {
                    fs = new FileStream(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"] + CurrentFilename), FileMode.CreateNew);
                }
                else
                {
                    fs = new FileStream(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"] + FileName), FileMode.Append);
                }

                ms.WriteTo(fs);

                ms.Close();
                fs.Close();
                fs.Dispose(); 

                //FileStream fs = new FileStream(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"] + CurrentFilename), FileMode.CreateNew);

                //fs.Write(Data, 0, Data.Length);

                // written successfully...
                //fs.Close();

            }
            catch (Exception e)
            {
                return e.Message;
            }
            if (Append)
                return ConfigurationSettings.AppSettings["DroppedURL"] + Server.UrlPathEncode(FileName);

            return ConfigurationSettings.AppSettings["DroppedURL"] + Server.UrlPathEncode(CurrentFilename);
        }
        #endregion

        #region ListFiles
        [WebMethod]
        public String[] ListDroppedFiles(String UploadSecret)
        {
            if (UploadSecret != ConfigurationSettings.AppSettings["UploadSecret"])
            {
                return new String[1] { "UploadSecret wrong!" };
            }

            String[] TempFiles = Directory.GetFiles(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"]));

            List<String> Output = new List<string>();

            foreach (String File in TempFiles)
            {
                Output.Add(ConfigurationSettings.AppSettings["DroppedURL"] + File.Remove(0, File.LastIndexOf("\\") + 1));
            }

            return Output.ToArray();
        }
        #endregion

        #region DeleteFile
        [WebMethod]
        public String[] DeleteFile(String FileName, String UploadSecret)
        {
            if (UploadSecret != ConfigurationSettings.AppSettings["UploadSecret"])
            {
                return new String[1] { "UploadSecret wrong!" };
            }

            if (File.Exists(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"]) + FileName))
            {
                File.Delete(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"]) + FileName);
            }

            if (File.Exists(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"]) + FileName))
            {
                return new String[1] { "File could not be deleted" };
            }
            else
                return ListDroppedFiles(UploadSecret);
        }
        #endregion

        #region RandomFile
        [WebMethod]
        public String GetRandomFilename(String UploadSecret)
        {
            if (UploadSecret != ConfigurationSettings.AppSettings["UploadSecret"])
            {
                return "UploadSecret wrong!";
            }

            String[] TempFiles = Directory.GetFiles(Server.MapPath(ConfigurationSettings.AppSettings["DroppedPath"]));

            Random rand = new Random();

            int randomnumber = rand.Next(TempFiles.Length);

            return ConfigurationSettings.AppSettings["DroppedURL"] + TempFiles[randomnumber].Remove(0, TempFiles[randomnumber].LastIndexOf("\\") + 1);
        }
        #endregion
    }
}
